<?php

namespace Slovocast\Domain\Entity;

use Slovocast\Domain\Entity as EntityTrait;

class Image
{
    use EntityTrait;

    public function __construct(
        private string $url,
        private string $title,
        private int $width,
        private int $height,
    ) { }

    public function getUrl(): string
    {
        return $this->url;
    }

    public function getTitle(): string
    {
        return $this->title;
    }

    public function getWidth(): int
    {
        return $this->width;
    }

    public function getHeight(): int
    {
        return $this->height;
    }

    /**
     * @param array $props Each property name as the key, and then the value
     */
    public static function fromArray(array $props): Image
    {
        $image = new self(
            $props['url'],
            $props['title'],
            $props['height'],
            $props['width'],
        );

        if ($props['id']) {
            $image->setId($props['id']);
        }

        if ($props['updatedAt']) {
            $image->setUpdatedAt($props['updatedAt']);
        }

        if ($props['createdAt']) {
            $image->setCreatedAt($props['createdAt']);
        }

        return $image;
    }
}
