<?php

namespace Slovocast\Domain\Factory;

use Slovocast\Domain\Entity\Channel;
use Slovocast\Domain\FactoryInterface;

class ChannelFactory implements FactoryInterface
{
    public static function fromArray(array $props): Channel
    {
        $channel = new Channel(
            $props['name'],
            $props['slug'] ?? '',
            $props['description'] ?? '',
            $props['link'] ?? '',
            $props['language'] ?? '',
            $props['copyright'] ?? '',
            $props['explicit'] ?? false
        );

        if (isset($props['id'])) {
            $channel->setId($props['id']);
        }

        if (isset($props['createdAt'])) {
            $channel->setCreatedAt($props['createdAt']);
        }

        if (isset($props['updatedAt'])) {
            $channel->setUpdatedAt($props['updatedAt']);
        }

        return $channel;
    }

    public static function toArray(Channel $channel): array
    {
        return [];
    }
}
